Bug 643890

Summary: dhclient refuses to prepend ipv6 nameservers
Product: [Fedora] Fedora Reporter: Peter Lemenkov <lemenkov>
Component: dhcpAssignee: Jiri Popelka <jpopelka>
Status: ASSIGNED --- QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: low    
Version: 23CC: jaroslaw.polok, jpopelka, kenyon
Target Milestone: ---Keywords: Reopened
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2012-08-16 17:58:21 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:

Description Peter Lemenkov 2010-10-18 08:42:06 EDT
I've got eth1 interface with both ipv4 and ipv6 addresses. I'm trying to prepend another one DNS server by adding 

prepend domain-name-servers 8.8.8.8 ;

to the corresponding config-file ( /etc/dhcp/dhclient-eth1.conf ). Everything is fine so far - I've got fully working /etc/resolv.conf :


[root@work ~]# cat /etc/resolv.conf
; generated by /sbin/dhclient-script
search example.ru
nameserver 8.8.8.8
nameserver 192.168.0.6
nameserver 192.168.1.6
[root@work ~]#

(I Removed actual IP addresses for two private DNS). Ok, now I'm trying to prepend IPv6 dns-resolver (public one, from Hurricane Electric) by adding the following line to /etc/dhcp/dhclient-eth1.conf :

prepend domain-name-servers 2001:470:20::2 ;

Ok, now restarting network with "service network restart" and all I get is two private dns:

[root@work ~]# cat /etc/resolv.conf
; generated by /sbin/dhclient-script
search example.ru
nameserver 192.168.0.6
nameserver 192.168.1.6
[root@work ~]#

and the following in my /var/lob/messages:

Oct 18 16:40:25 work dhclient[10645]: /etc/dhcp/dhclient-eth1.conf line 1: semicolon expected.
Oct 18 16:40:25 work dhclient[10645]: prepend domain-name-servers 2001:
Oct 18 16:40:25 work dhclient[10645]:                                  ^
Oct 18 16:40:25 work dhclient[10645]: /etc/dhcp/dhclient-eth1.conf line 1: expecting a statement.
Oct 18 16:40:25 work dhclient[10645]: prepend domain-name-servers 2001:470:20::2 ;
Oct 18 16:40:25 work dhclient[10645]:                                             ^
Oct 18 16:40:25 work dhclient[10645]: /etc/dhcp/dhclient-eth1.conf line 3: semicolon expected.
Oct 18 16:40:25 work dhclient[10645]: send 
Oct 18 16:40:25 work dhclient[10645]:  ^
Comment 1 Jiri Popelka 2010-10-18 11:37:46 EDT
(In reply to comment #0)
> prepend domain-name-servers 2001:470:20::2 ;
correct is
prepend dhcp6.name-servers 2001:470:20::2;
(see dhcp-options(5) man page)
but it seems that dhclient is really ignoring it.

I'm trying to figure out what's wrong.
Comment 2 Jiri Popelka 2010-10-20 05:58:51 EDT
I asked upstream, but no response.
https://lists.isc.org/pipermail/dhcp-users/2010-October/012126.html
Comment 3 Peter Lemenkov 2010-10-20 07:39:25 EDT
I must admit that networking sub-system is really complex!

I looked at the sources and sound something interesting (in /sbin/dhclient-script).

 I just added echo ${reason} right before "case "${reason}" in" in /sbin/dhclient-script and found that it gets PREINIT and REBOOT while has being configured for ipv4, but only PREINIT6 while has being configured for ipv6. 

The dhconfig function is called in case of "REBOOT" for ipv4 but dh6config is never called (no BOUND6|RENEW6|REBIND6|DEPREF6 parameter was ever passed to this script).

I also looked at the dhcp client's sources and found that no BOUND6|RENEW6|REBIND6|DEPREF6 strings were ever hardcoded so dh6config have no chances to be called. So there are two possible issues - 

a) /sbin/dhclient-scrips is out of sync with dhclient (no BOUND6|RENEW6|REBIND6|DEPREF6 in dhclient)
b) dhclient erroneously doesn't try to execute post-INIT hooks (REBOOT, in case of ipv4).
Comment 4 Fedora End Of Life 2012-08-16 17:58:24 EDT
This message is a notice that Fedora 14 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 14. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained.  At this time, all open bugs with a Fedora 'version'
of '14' have been closed as WONTFIX.

(Please note: Our normal process is to give advanced warning of this 
occurring, but we forgot to do that. A thousand apologies.)

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, feel free to reopen 
this bug and simply change the 'version' to a later Fedora version.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we were unable to fix it before Fedora 14 reached end of life. If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora, you are encouraged to click on 
"Clone This Bug" (top right of this page) and open it against that 
version of Fedora.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 5 Fedora End Of Life 2013-04-03 16:06:21 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19
Comment 6 Fedora End Of Life 2015-01-09 16:46:11 EST
This message is a notice that Fedora 19 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 19. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained. Approximately 4 (four) weeks from now this bug will
be closed as EOL if it remains open with a Fedora 'version' of '19'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 19 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 7 Fedora End Of Life 2015-11-04 10:30:23 EST
This message is a reminder that Fedora 21 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 21. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '21'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 21 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.